const system=require("../system")
class TaskBase{
  constructor(className){
     this.redisClient=system.getObject("util.redisClient");
     this.serviceName=className;
     this.isThrough=false;
     this.cacheManager=system.getObject("db.common.cacheManager");
     this.db = system.getObject("db.common.connection").getCon();
  }
  async beforeTask(params){
     console.log("前置操作......",this.serviceName);
  }
  async postTask(params){
    console.log("后置操作......",this.serviceName);
 }
  async doTask(params){
    try {
      await this.beforeTask(params);
      if(!this.isThrough){
        await this.subDoTask(params);
      }
      await this.postTask(params);
      //日志记录
       console.log(JSON.stringify({
        optitle:this.serviceName+"，任务成功执行完成",
        op:"base/db/task.base.js",
        content:"",
        clientIp:"",
        status:"ok"
      }));

    } catch (e) {
      //日志记录
      console.log(JSON.stringify({
        optitle:this.serviceName+"，任务成功执行完成",
        op:"base/db/task.base.js",
        content:"",
        clientIp:"",
        status:"error"
      }));
    }
  }
  async subDoTask(params){
    throw new Error("请在子类中重写此方法进行操作业务逻辑............................!");
  }
  static getServiceName(ClassObj){
    return ClassObj["name"];
  }
  async apiCallWithAk(url,params){
    var acckapp=await this.cacheManager["ApiAccessKeyCache"].cache(settings.appKey);
    var acck=acckapp.accessKey;
    //按照访问token
    var restResult=await this.restS.execPostWithAK(params,url,acck);
    if(restResult){
      if(restResult.status==0){
        var resultRtn=restResult.data;
        return resultRtn;
      }else{
        await  this.cacheManager["ApiAccessKeyCache"].invalidate(settings.appKey);
        return null;
      }
    }
    return null;
  }
}
module.exports=TaskBase;
